
		'PROGRAMME POUR LE DECODAGE DES SIGNAUX DTMF
		'A L'AIDE D'UN MICROCONTROLEUR MOTOROLA
		'	       68HC811E2FN.
		'AFFICHAGE SUR UN LCD 1 LIGNE DE 16 CARACTERES.
		
		'Copyright Pierre RICHON . Mai 1998 .


ProgramPointer	$F800		        'initialise le 68HC11E2FN.
DataPointer	$0002
StackPointer	$00E8
	sect	text
	cli				'autorise le debugger.
	ldx	#_data_s
	bra	_crt2

_crt1	clr	0,x			'au reset,met  0 les variables.
	inx
_crt2	cpx	#_data_e
	bne	_crt1

	sect	data
_data_s	equ*

byte PORTA	at $1000		'dclaration des registres
byte PIOC	at $1002		'utiliss dans le programme.
byte PORTC	at $1003		'si une modification intervient,
byte PORTB	at $1004		'ne pas oublier de dclarer ici 
byte PORTCL	at $1005		'les nouveaux registres utiliss.
byte DDRC	at $1007
byte PORTD	at $1008
byte DDRD	at $1009
byte TMSK2	at $1024
byte TFLG2	at $1025
byte PACTL	at $1026

	'dclaration des variables utilises.

byte lcdbuf(16)				'relatif  la gestion de l'afficheur.

byte ch(16)				'tableau d'enregistrement des signaux.
byte N					'indice du comptage des signaux.
byte boucle				'dclaration de la boucle sans fin.
byte K				
byte i					'indice de comptage remise  0.
byte tictac				'indice de comptage du nombre d'inter
					'-ruptions

DDRD = DDRD or $3C			'mise en sortie de PD2  PD5.			
lcdinit()				'initialisation de l'afficheur.
debut:					
PACTL = PACTL or $3			'dtermine la priodicit des inter
					'-ruptions.
TMSK2 = TMSK2 or $40			'dmarre le timer.
print "  ATTENTE DTMF  "		'le dcodeur est en attente de signal.

N = 0
for boucle = 0 to 1 step 0		'boucle sans fin
     
if PIOC and $80  then         		'test bit STAF de PIOC,
					's'il est  1 autorise la lecture de 
					'PORTCL.
ch(N) = PORTCL				'enregistrement d'un signal.
print "*"				'avertit de la prsence d'un signal.
N = N+1
end if
if N > 10 then				'securit de dpassement.
TMSK2 = TMSK2 and not $FC		'arrte le timer si dpassement.
print "  DEPASSEMENT   "
tempo(500)
goto debut				'redmarre  l'tiquette:dbut.
end if 
next boucle				'et a repart pour un tour...!

interrupt function rtiint at $FFF0	'dclaration des interruptions 
					'en temps rel.
	if N >= 1 then
	tictac = tictac + 1		'comptage des interruptions  partir
					' de la rception du 1 signal
	end if
	if tictac = 214 then		'une interruption = 0,0327s,
					'pour 7secondes on a: 214 int.
	tictac = tictac			'blocage du comptage  la mme valeur.
	
	N = 0 
for K = 0 to 16
if ch(N) = $0 	then print "_"		'traduction des signaux enregistrs.
if ch(N) = $F1 	then print "1"		'(par la lecture du PORTCL au complet, 
if ch(N) = $F2 	then print "2"		'le PORTC tant totalement configur 
if ch(N) = $F3 	then print "3"		'en entre et chacun de ses 8 bits 
if ch(N) = $F4 	then print "4"		'port au niveau haut par un rseau  
if ch(N) = $F5 	then print "5"		'de rsistances de 10K ,on introduit 
if ch(N) = $F6 	then print "6"		' chaque fois les valeurs  1 des   
if ch(N) = $F7 	then print "7"		'bits 4,5,6,et7 ). 
if ch(N) = $F8 	then print "8" 
if ch(N) = $F9 	then print "9" 
if ch(N) = $FA 	then print "0"
if ch(N) = $FB 	then print "*" 
if ch(N) = $FC 	then print "#" 
if ch(N) = $FD 	then print "A" 
if ch(N) = $FE 	then print "B"
if ch(N) = $FF  then print "C"
if ch(N) = $F0  then print "D"
N = N+1
next K

					'TELECOMMANDE:
if ch(0) = $FA and ch(1) = $F4 then	'ici par exemple si le premier
PORTD = PORTD or $20			'chiffre enregistr est "0" et
end if					'le deuxime "4" ,la sortie 
					'PORTD5 passe au niveau haut.
N = 0
for i = 0 to 16				'mise  0 des signaux enregistrs.
	ch(N) = $0
	N = N+1
next i

					'TELECOMMANDE:
PORTD = PORTD and not $20	        'on peut remettre au niveau bas
					'la sortie PORTD5 de cette faon.

tictac = 0				'rinitialisation du comptage des int.
N= 0
end if
TFLG2 = TFLG2 or $40		        'on autorise  nouveau les inter
					'-ruptions.
end function

		'GESTION DE L'AFFICHEUR.  Ne pas modifier...!
function lcdnib(c)
	PORTB = (c and $4F) or $30
	PORTB = PORTB or $80
	PORTB = PORTB and $7F
end function

function lcdnibw(c)
	lcdnib(c)
	tempo(-1)
end function

function lcdputc(c)
	lcdnib(c/16)
	lcdnibw(c and $F)
end function

function lcdinit()
	byte c
	PORTB = $30
	tempo(5)
	lcdnib(3)
	tempo(1)
	lcdnib(3)
	tempo(1)
	lcdnibw(3)
	lcdnibw(2)
	lcdputc($28)
	lcdputc($8)
	lcdputc(1)
	tempo(1)
	lcdputc($6)
	lcdputc($E)
	for c = 0 to 15 step 1
	print lcdbuf(c)
	next c
	putchar(lcdbuf(c))
end function

function putchar(c)
	byte d
	for d = 0 to 14 step 1
		lcdbuf(d) = lcdbuf(d+1)
	next d
	lcdbuf(15) = c
	lcdputc($80)
	for d = 0 to 15 step 1
		if d = 8 then lcdputc($80 + $28)
		lcdnib((lcdbuf(d)/16) or $40)
		lcdnibw(lcdbuf(d) or $40)
	next d
end function

		'DETERMINATION D'UNE TEMPORISATION.
function tempo(cnt)
	int bcl
	for cnt = cnt to 0 step -1
	for bcl = 0 to 100 step 1
	next bcl
	next cnt
end function 

